/**
 * User: Clinton Begin
 * Date: Mar 8, 2003
 * Time: 11:32:37 AM
 */
package examples;

import com.ibatis.common.util.*;

import java.sql.*;
import java.util.*;

import examples.sqlmap.*;
import examples.dao.CrudExample;
import examples.scriptrunner.ScriptRunnerExample;

/**
 * ******************************************************************************
 *                           THIS IS NOT AN EXAMPLE!!!
 *                           THIS IS NOT AN EXAMPLE!!!
 *                           THIS IS NOT AN EXAMPLE!!!
 * ******************************************************************************
 * <P>
 * This is just a runner class.
 * <P>
 *
 * Please refer to the other XxxxxxxExample classes for examples of how to use the
 * iBATIS database layer.
 */
public class RunAllExamples extends BaseExample implements Runnable {


  private static final int THREADS = 50;
  private static final int STATEMENTS = 19;

  private static final Stopwatch stopwatch = new Stopwatch();

  public static void main(String[] args) throws Exception {

    // -- Set this to false to keep the examples quiet.
    setLogEnabled(false);

    // -- ScriptRunnerExample
    // -- We'll borrow the already configured connection from an SQL Map
    Connection conn = SqlMapConfigExample.getSqlMap().getCurrentDataSource().getConnection();
    ScriptRunnerExample.runInitializationScript(conn, "examples/ddl/hsql-init.sql");
    conn.commit();
    conn.close();

    // Give everything a chance to initialize
    new RunAllExamples().run();

    stopwatch.reset();

    // Let's throw a bunch of threads against this to give it a good workout.
    ThreadGroup group = new ThreadGroup("Examples");
    long t = System.currentTimeMillis();
    List threadList = new ArrayList();
    for (int i = 0; i < THREADS; i++) {
      Thread thread = new Thread(group, new RunAllExamples());
      threadList.add(thread);
    }
    for (int i = 0; i < THREADS; i++) {
      ((Thread) threadList.get(i)).start();
    }
    while (group.activeCount() > 0) {
      Thread.sleep(10);
    }

    t = System.currentTimeMillis() - t;
    System.out.println("Ran " + (STATEMENTS * THREADS) + " statements using " + THREADS + " threads in " + t + " milliseconds.");

//    SqlMapDaoTransactionPool pool = (SqlMapDaoTransactionPool)daoManager.getTransactionPool();
//    SqlMap sqlMap = pool.getSqlMapFromLocalTransaction();
//    SimpleDataSource ds = (SimpleDataSource)sqlMap.getCurrentDataSource();
//    System.out.println(ds.getStatus());

//    System.out.println ("Statement Cache Hit Ratio: " + SqlMapConfigExample.getSqlMap().getStatementCacheHitRatio());
//    System.out.println ("Data Cache Hit Ratio: " + SqlMapConfigExample.getSqlMap().getDataCacheStats());


//    System.out.println (stopwatch);
//    System.out.println (SqlMapConfigExample.getSqlMap().getDataCacheStats());

    SqlMapConfigExample.getSqlMap().flushCache();

    System.out.flush();
    System.err.flush();

  }

  private static Object threadLock = new Object();
  private static int threadCount = 0;

  public void run() {
    synchronized (threadLock) {
      println((++threadCount) + " Threads Running (start)");
    }
    try {
      println("[**** QUERY FOR OBJECT ***]");
      QueryForObjectExample.queryForObjectExample();
      println("[**** QUERY FOR LIST ***]");
      QueryForListExample.queryForListExample();
      println("[**** SIMPLE TYPES ***]");
      SimpleTypesExample.simpleTypesExample();
      println("[**** HASH MAP ***]");
      HashMapExample.hashMapExample();
      println("[**** ROW HANDLER ***]");
      RowHandlerExample.rowHandlerExample();
      println("[**** DYNAMIC QUERY ***]");
      //DynamicQueryExample.dynamicQueryExample();
      println("[**** INSERT ***]");
      int id = InsertExample.insertExample();
      println("[**** UPDATE ***]");
      UpdateExample.updateExample(id);
      println("[**** DELETE ***]");
      DeleteExample.deleteExample(id);

      println("[**** DAO INSERT ***]");
      id = CrudExample.insertExample();
      println("[**** DAO UPDATE ***]");
      CrudExample.updateExample(id);
      println("[**** DAO GET ***]");
      CrudExample.getAccountExample();
      println("[**** DAO DELETE ***]");
      CrudExample.deleteExample(id);

    } catch (Exception e) {
      e.printStackTrace(System.out);
    } finally {
      synchronized (threadLock) {
        println((--threadCount) + " Threads Running (finish)");
      }
    }
  }

}
