/**
 * User: Clinton Begin
 * Date: Mar 10, 2003
 * Time: 8:48:27 PM
 */
package examples.dao;

import com.ibatis.db.dao.DaoManager;
import com.ibatis.common.resources.Resources;
import com.ibatis.common.exception.*;

import examples.BaseExample;

public class DaoConfigExample extends BaseExample {

  // -- DaoManager is thread safe
  protected static final DaoManager daoManager;

  static {
    try {
      // -- Configure the DaoManager by passing in the dao.xml as a Reader.
      // -- Once this is done you can request a DaoManager instance for
      // -- each context that you defined in the dao.xml.

      DaoManager.configure(Resources.getResourceAsReader("examples/dao/dao.xml"));
//      DaoManager.configure(Resources.getResourceAsReader("examples/dao/dao.xml"), 
//          Resources.getResourceAsProperties("examples/dao/dao.properties"));


      // -- Return the default DaoManager instance.  Optionally you can
      // -- explicitly state the name of the instance you want to get.
      // -- Explicitly naming the instance is highly recommended when dealing
      // -- with multiple databases.
      // return DaoManager.getInstance ("Example");

      daoManager = DaoManager.getInstance("SqlMapExample");

    } catch (Exception e) {
      // If we fail here we just want to fail gracefully.
      // Errors at this point will be unrecoverable and we
      // want to know about them at system startup time,
      // not after hours of operation.
      throw new NestedRuntimeException("Error initializing BaseDaoExample.  Cause: " + e, e);
    }
  }


  public static DaoManager getDaoManager() {
    return daoManager;
  }

}
