/**
 * User: Clinton Begin
 * Date: Mar 8, 2003
 * Time: 7:43:17 PM
 */
package examples.sqlmap;

import com.ibatis.db.sqlmap.SqlMap;
import examples.domain.Account;
import examples.BaseExample;

import java.sql.*;

public class DeleteExample extends BaseExample {

  public static void deleteExample(int id)
      throws SQLException {
    // Get our configured SqlMap instance
    SqlMap sqlMap = SqlMapConfigExample.getSqlMap();

    try {
      // -- Start the transaction
      sqlMap.startTransaction();

      // -- Get the existing account from the database
      Account newAccount = (Account) sqlMap.executeQueryForObject("getAccount", new Integer(id));

      // -- DELETE the Account
      sqlMap.executeUpdate("deleteAccount", newAccount);

      // -- Commit the transaction
      sqlMap.commitTransaction();

      // -- Check to see if the record was deleted correctly (just for testing)
      checkDelete(sqlMap, id);
    } catch (Exception e) {
      // -- With the introduction of stacked transactions, you'll
      // -- want to get in the habit of only calling rollback
      // -- in the event of an error.  Otherwise you might rollback
      // -- the next transaction in the stack.
      sqlMap.rollbackTransaction();
      throw (SQLException) e.fillInStackTrace();
    }
  }

  private static void checkDelete(SqlMap sqlMap, int id) throws SQLException {
    // -- Check to see if the record was deleted correctly (just for testing)
    sqlMap.startTransaction();
    Account account = (Account) sqlMap.executeQueryForObject("getAccount", new Integer(id));
    if (account != null) throw new SQLException("Account was not deleted from the database correctly.");
    println("Deleted (should be null): " + account);
    sqlMap.commitTransaction();
  }


}
