/**
 * User: Clinton Begin
 * Date: Mar 8, 2003
 * Time: 12:00:45 PM
 */
package examples.sqlmap;

import com.ibatis.db.sqlmap.SqlMap;

import java.sql.*;
import java.util.*;

import examples.BaseExample;

public class HashMapExample extends BaseExample {

  public static void hashMapExample()
      throws SQLException {
    // Get our configured SqlMap instance
    SqlMap sqlMap = SqlMapConfigExample.getSqlMap();

    try {
      // -- Start the transaction
      sqlMap.startTransaction();

      // -- Get the List of email Strings that are 'like' the String
      // -- passed in as the key. This demonstrates how simple types like
      // -- String and Integer can be used as both parameters and results.
      HashMap map = new HashMap();
      map.put("id", new Integer(1));

      map = (HashMap) sqlMap.executeQueryForObject("getAccountAsHashMap", map);

      println("HashMap: " + map);

      // -- Commit the transaction
      sqlMap.commitTransaction();
    } catch (Exception e) {
      // -- With the introduction of stacked transactions, you'll
      // -- want to get in the habit of only calling rollback
      // -- in the event of an error.  Otherwise you might rollback
      // -- the next transaction in the stack.
      sqlMap.rollbackTransaction();
      throw (SQLException) e.fillInStackTrace();
    }
  }

}
