/**
 * User: Clinton Begin
 * Date: Mar 8, 2003
 * Time: 11:59:38 AM
 */
package examples.sqlmap;

import com.ibatis.db.sqlmap.SqlMap;

import java.sql.*;
import java.util.*;

import examples.BaseExample;

public class QueryForListExample extends BaseExample {

  public static void queryForListExample()
      throws SQLException {
    // Get our configured SqlMap instance
    SqlMap sqlMap = SqlMapConfigExample.getSqlMap();

    try {
      // -- Start the transaction
      sqlMap.startTransaction();

      // -- Get the List of Account objects.  No key is required for this
      // -- particular query.
      List list = sqlMap.executeQueryForList("getAllAccounts", null);

      // -- You can also specify a range of results
      // int skipRecords = 2;
      // int maxResults = 3;
      // list = sqlMap.executeQueryForList("getAllAccounts", null, skipRecords, maxResults);

      for (int i = 0; i < list.size(); i++) {
        println("Account: " + list.get(i));
      }

      list = sqlMap.executeQueryForList("getAllAccountsAsHashMaps", null);

      for (int i = 0; i < list.size(); i++) {
        println("AccountMap: " + list.get(i));
      }

      list = sqlMap.executeQueryForList("getAccount", new Integer(1));
      for (int i = 0; i < list.size(); i++) {
        println("Single: " + list.get(i));
      }

      // -- Commit the transaction
      sqlMap.commitTransaction();
    } catch (Exception e) {
      // -- With the introduction of stacked transactions, you'll
      // -- want to get in the habit of only calling rollback
      // -- in the event of an error.  Otherwise you might rollback
      // -- the next transaction in the stack.
      sqlMap.rollbackTransaction();
      throw (SQLException) e.fillInStackTrace();
    }
  }


}
