/**
 * User: Clinton Begin
 * Date: Mar 8, 2003
 * Time: 2:51:44 PM
 */
package examples.sqlmap;

import com.ibatis.db.sqlmap.RowHandler;
import com.ibatis.db.sqlmap.SqlMap;

import java.sql.*;

import examples.BaseExample;

public class RowHandlerExample extends BaseExample {

  public static void rowHandlerExample()
      throws SQLException {
    // Get our configured SqlMap instance
    SqlMap sqlMap = SqlMapConfigExample.getSqlMap();

    try {
      // -- Start the transaction
      sqlMap.startTransaction();

      // -- Get the List of Account objects.  No key is required for this
      // -- particular query.

      RowHandler rowHandler = new ExampleRowHandler();
      sqlMap.executeQueryWithRowHandler("getAllAccounts", null, rowHandler);

      // -- Commit the transaction
      sqlMap.commitTransaction();
    } catch (Exception e) {
      // -- With the introduction of stacked transactions, you'll
      // -- want to get in the habit of only calling rollback
      // -- in the event of an error.  Otherwise you might rollback
      // -- the next transaction in the stack.
      sqlMap.rollbackTransaction();
      throw (SQLException) e.fillInStackTrace();
    }
  }


}
