/**
 * User: Clinton Begin
 * Date: Jan 16, 2003
 * Time: 9:17:28 PM
 */
package examples.sqlmap;

import com.ibatis.common.resources.Resources;
import com.ibatis.common.exception.*;
import com.ibatis.db.sqlmap.*;

import java.io.*;

public class SqlMapConfigExample {

  // -- SqlMap instances are thread safe.
  protected static final SqlMap sqlMap;

  static {

    try {

      // -- Load the SQL Map configuration XML file a Reader or a File.
      // -- The iBATIS common library includes a handy Resources utility class perfect for this.
      Reader reader = Resources.getResourceAsReader("examples/sqlmap/maps/SqlMapConfigExample.xml");

      // -- You can disable XML validation, it is enabled by default.
      // XmlSqlMapBuilder.setValidationEnabled(true);

      // Use the XmlSqlMapBuilder to build the SQL Map from the reader.
      sqlMap = XmlSqlMapBuilder.buildSqlMap(reader);

    } catch (Exception e) {
      // If we fail here we just want to fail gracefully.
      // Errors at this point will be unrecoverable and we
      // want to know about them at system startup time,
      // not after hours of operation.
      throw new NestedRuntimeException("Error initializing BaseSqlMapExample.  Cause: " + e, e);
    }
  }

  public static SqlMap getSqlMap() {
    return sqlMap;
  }

}
